#################################################################
#     ___                       __                 _            #
#    /___\_ __  _   ___  __    / _\ ___ _ ____   _(_) ___ ___   #
#   //  // '_ \| | | \ \/ /    \ \ / _ \ '__\ \ / / |/ __/ _ \  #
#  / \_//| | | | |_| |>  <     _\ \  __/ |   \ V /| | (_|  __/  #
#  \___/ |_| |_|\__, /_/\_\    \__/\___|_|    \_/ |_|\___\___|  #
#               |___/                                           #
#                                                               #
#                                                               #
#                  Module: gs_onyx.inc                          #
#                  Auteur : ludo`                               #
#                  Site : www.zone-irc.com                      #
#                                                               #
#################################################################


##############################
#----------------------------#
# Configuration de GuardServ #
#----------------------------#
##############################
## Activation de GuardServ (0=dsactiv 1=activ)
set onyx(gs:global:active) "1"
## Pseudo de GuardServ
set onyx(gs:pseudo) "GuardServ"
## Identd de GuardServ
set onyx(gs:ident) "guardserv"
## Realname de GuardServ
set onyx(gs:real) "Gardien des salons ouvert --> Onyx Service"
## Host de GuardServ
set onyx(gs:host) "guardserv.domaine.tld"
## Mode de GuardServ
set onyx(gs:mode) "+SBqW"
## Salon de GuardServ
set onyx(gs:salon) "#Guard"
## Mode de GuardServ sur le salon (q=owner a=protect o=op h=halfop v=voice)
set onyx(gs:mode_pseudo) "+o"
## Mode du salon de GuardServ
set onyx(gs:mode_salon) "+ntsi"
## Mode de GuardServ sur le salon garder (q=owner a=protect o=op h=halfop v=voice)
set onyx(gs:mode:salon) "+a"
## Topic mis si aucun enregistr (salle=nom du salon)
set onyx(gs:topic) "Bienvenue sur salle"

#############################################################################################################################

###############
# Fichiers db #
###############
proc gs:db {} {
  set nom_db "gestion.db salons.db"
  foreach nom_db2 $nom_db { 
    if {![file exists "db/gs_onyx/$nom_db2"]} { set gs_db [open db/gs_onyx/$nom_db2 a+]; close $gs_db }
  }
}

#############
# Lancement #
#############
proc gs:lancement {} {
  global onyx
  ## Gestion
  catch {open db/gs_onyx/gestion.db r} gestion_gs
  while {![eof $gestion_gs]} { 
    gets $gestion_gs var
    if {$var!=""} { set [lindex $var 0] [lrange $var 1 end] } 
  }
  catch {close $gestion_gs}
  ## Connextion
  if {$onyx(gs:global:active)=="1"} {
    putdcc $onyx(idx) ":$onyx(link) NICK $onyx(gs:pseudo) 1 [unixtime] $onyx(gs:ident) $onyx(gs:host) $onyx(link) :$onyx(gs:real)"
    putdcc $onyx(idx) ":$onyx(gs:pseudo) MODE $onyx(gs:pseudo) $onyx(gs:mode)"
    putdcc $onyx(idx) ":$onyx(gs:pseudo) JOIN $onyx(gs:salon)"
    putdcc $onyx(idx) ":$onyx(gs:pseudo) MODE $onyx(gs:salon) $onyx(gs:mode_pseudo) $onyx(gs:pseudo)"
    putdcc $onyx(idx) ":$onyx(gs:pseudo) MODE $onyx(gs:salon) $onyx(gs:mode_salon)"
    putdcc $onyx(idx) ":$onyx(gs:pseudo) SQLINE $onyx(gs:pseudo) :Rserv  Onyx Service"
    ## Salon
    catch {open db/gs_onyx/salons.db r} salons
    while {![eof $salons]} { 
      gets $salons verif
      if {$verif!=""} {
        set salon_garde [lindex $verif 0]
        putdcc $onyx(idx) ":$onyx(gs:pseudo) JOIN $salon_garde"
        putdcc $onyx(idx) ":$onyx(gs:pseudo) MODE $salon_garde $onyx(gs:mode:salon) $onyx(gs:pseudo)"
        set onyx(gs:resalon:$salon_garde) ok
        putdcc $onyx(idx) ":$onyx(gs:pseudo) TOPIC $salon_garde"
      } 
    }
    catch {close $salons}
  }
  ############
  if {$onyx(gs:global:active)=="1"  && [string tolower $onyx(salon)]!=[string tolower $onyx(gs:salon)]} {
    putdcc $onyx(idx) ":$onyx(gs:pseudo) JOIN $onyx(salon)"
    putdcc $onyx(idx) ":$onyx(gs:pseudo) MODE $onyx(salon) $onyx(mode_bots_salon) $onyx(gs:pseudo)"
  }
}

##########
# Divers #
##########
proc gs:divers {arg} {
  global onyx
  set arg [join [split $arg]]
  set pour [lindex $arg 0]
  set idx2 [lindex $arg 1]   
  if {$pour=="help"} { putdcc $idx2 "GuardServ : 3.connexion_gs 14(connexion de $onyx(gs:pseudo)) 1| 4.deconnexion_gs 14(dconnexion de $onyx(gs:pseudo))" }
  if {$pour=="status"} {
    if {$onyx(gs:global:active)=="1"} { putdcc $idx2 "1GuardServ (3Activ1) 3: 14Pseudo: $onyx(gs:pseudo) Salon: $onyx(gs:salon)" } else { putdcc $idx2 "1GuardServ (4Dsactiv1) 3: 14Pseudo: $onyx(gs:pseudo) Salon: $onyx(gs:salon)" }
  }
  if {$pour=="gestion"} {
    set sauv_gs [open db/gs_onyx/gestion.db w+]
    puts $sauv_gs "onyx(gs:global:active) $onyx(gs:global:active)"
    puts $sauv_gs "onyx(gs:pseudo) $onyx(gs:pseudo)"
    puts $sauv_gs "onyx(gs:ident) $onyx(gs:ident)"
    puts $sauv_gs "onyx(gs:host) $onyx(gs:host)"
    puts $sauv_gs "onyx(gs:real) $onyx(gs:real)"
    puts $sauv_gs "onyx(gs:salon) $onyx(gs:salon)"
    close $sauv_gs
  }
  if {$pour=="chanlog"} {
    if {$onyx(gs:global:active)=="1"} { putdcc $onyx(idx) ":$onyx(gs:pseudo) PART $onyx(salon) :Changement de salon" }
  }
}

###########
# gs:load #
###########
proc gs:load {} {
   global onyx
   putdcc $onyx(idx) ":$onyx(os:pseudo) PRIVMSG $onyx(salon) :Chargement de $onyx(gs:pseudo) Bot de garde salon."
   gs:db
   gs:lancement
}

#############
# gs:unload #
#############
proc gs:unload {} {
   global onyx
   putdcc $onyx(idx) ":$onyx(os:pseudo) PRIVMSG $onyx(salon) :Dchargement de $onyx(gs:pseudo)."
   putdcc $onyx(idx) ":$onyx(gs:pseudo) UNSQLINE $onyx(gs:pseudo)"
   putdcc $onyx(idx) ":$onyx(gs:pseudo) QUIT :Dcharg de Onyx Service."
}

###################
# gs:connexion_gs #
###################
bind dcc n connexion_gs gs:connexion_gs
proc gs:connexion_gs {nick idx arg} { 
   global onyx
   if {$onyx(gs:global:active)=="0"} { 
     putdcc $idx "Connexion de $onyx(gs:pseudo)"
     set onyx(gs:global:active) 1
     set onyx(os:host:[string tolower $onyx(gs:pseudo)]) $onyx(gs:host)
     putdcc $onyx(idx) ":$onyx(link) NICK $onyx(gs:pseudo) 1 [unixtime] $onyx(gs:ident) $onyx(gs:host) $onyx(link) :$onyx(gs:real)"
     putdcc $onyx(idx) ":$onyx(gs:pseudo) MODE $onyx(gs:pseudo) $onyx(gs:mode)"
     putdcc $onyx(idx) ":$onyx(gs:pseudo) JOIN $onyx(gs:salon)"
     putdcc $onyx(idx) ":$onyx(gs:pseudo) MODE $onyx(gs:salon) $onyx(gs:mode_pseudo) $onyx(gs:pseudo)"
     putdcc $onyx(idx) ":$onyx(gs:pseudo) MODE $onyx(gs:salon) $onyx(gs:mode_salon)"
     putdcc $onyx(idx) ":$onyx(gs:pseudo) SQLINE $onyx(gs:pseudo) :Rserv  Onyx Service"
     if {[string tolower $onyx(salon)]!=[string tolower $onyx(gs:salon)]} {
       putdcc $onyx(idx) ":$onyx(gs:pseudo) JOIN $onyx(salon)"
       putdcc $onyx(idx) ":$onyx(gs:pseudo) MODE $onyx(salon) $onyx(mode_bots_salon) $onyx(gs:pseudo)"
     }
     ## Salon
     catch {open db/gs_onyx/salons.db r} salons
     while {![eof $salons]} { 
       gets $salons verif
       if {$verif!=""} {
         set salon_garde [lindex $verif 0]
         putdcc $onyx(idx) ":$onyx(gs:pseudo) JOIN $salon_garde"
         putdcc $onyx(idx) ":$onyx(gs:pseudo) MODE $salon_garde $onyx(gs:mode:salon) $onyx(gs:pseudo)"
         set onyx(gs:resalon:$salon_garde) ok
         putdcc $onyx(idx) ":$onyx(gs:pseudo) TOPIC $salon_garde"
       } 
     }
     catch {close $salons}
     onyx:gestion
   } else { putdcc $idx "$onyx(gs:pseudo) est dj connect..." }
}

#####################
# gs:deconnexion_gs #
#####################
bind dcc n deconnexion_gs gs:deconnexion_gs
proc gs:deconnexion_gs {nick idx arg} { 
   global onyx
   if {$onyx(gs:global:active)=="1"} { 
     putdcc $idx "Dconnexion de $onyx(gs:pseudo)"
     set onyx(gs:global:active) 0
     unset onyx(os:host:[string tolower $onyx(gs:pseudo)])
     putdcc $onyx(idx) ":$onyx(gs:pseudo) UNSQLINE $onyx(gs:pseudo)"
     putdcc $onyx(idx) ":$onyx(gs:pseudo) QUIT :$onyx(raison)" 
     onyx:gestion
     } else { putdcc $idx "$onyx(gs:pseudo) est dj dconnect..." }
}

###########
# gs:help #
###########
proc gs:help {arg} {
	global admin onyx
        set arg [join [split $arg]]
        set pseudo [lindex $arg 0]
        set vpseudo [string tolower $pseudo]
        set data [lindex $arg 2]
        set data2 [string tolower $data]
        set data3 [string tolower [lindex $arg 3]]
        if {$data2==""} {
          if {[info exists onyx(os:$vpseudo)] && [matchattr $onyx(os:$vpseudo) n]} { putdcc $onyx(idx) ":$onyx(gs:pseudo) Notice $pseudo :SET Permet de configurer $onyx(gs:pseudo)." }
          if {[info exists onyx(os:$vpseudo)] && [matchattr $onyx(os:$vpseudo) m]} { 
            putdcc $onyx(idx) ":$onyx(gs:pseudo) Notice $pseudo :SALON Action sur la liste des salons gard."
          }
        } elseif {$data2=="salon" && $data3==""} {
            putdcc $onyx(idx) ":$onyx(gs:pseudo) Notice $pseudo :SALON Action sur la liste des salons gard."
        } elseif {$data2=="salon" && $data3=="add"} {
            putdcc $onyx(idx) ":$onyx(gs:pseudo) Notice $pseudo :Syntax: /msg $onyx(gs:pseudo) salon add #salon"
            putdcc $onyx(idx) ":$onyx(gs:pseudo) Notice $pseudo :Permet d'ajouter un salon."
        } elseif {$data2=="salon" && $data3=="del"} {
            putdcc $onyx(idx) ":$onyx(gs:pseudo) Notice $pseudo :Syntax: /msg $onyx(gs:pseudo) salon del #salon"
            putdcc $onyx(idx) ":$onyx(gs:pseudo) Notice $pseudo :Permet de retir un salon."
        } elseif {$data2=="salon" && $data3=="list"} {
            putdcc $onyx(idx) ":$onyx(gs:pseudo) Notice $pseudo :Syntax: /msg $onyx(gs:pseudo) salon list"
            putdcc $onyx(idx) ":$onyx(gs:pseudo) Notice $pseudo :Permet de voir la liste des salons gard."
        } elseif {$data2=="set" && $data3==""} {
            putdcc $onyx(idx) ":$onyx(gs:pseudo) Notice $pseudo :Syntax: /msg $onyx(gs:pseudo) set"
            putdcc $onyx(idx) ":$onyx(gs:pseudo) Notice $pseudo :Permet de voir la configuration pogsible de $onyx(gs:pseudo)."
        } elseif {$data2=="set" && $data3=="pseudo"} {
            putdcc $onyx(idx) ":$onyx(gs:pseudo) Notice $pseudo :Syntax: /msg $onyx(gs:pseudo) set pseudo nouveau_pseudo"
            putdcc $onyx(idx) ":$onyx(gs:pseudo) Notice $pseudo :Permet de changer le pseudo du bot."
        } elseif {$data2=="set" && $data3=="ident"} {
            putdcc $onyx(idx) ":$onyx(gs:pseudo) Notice $pseudo :Syntax: /msg $onyx(gs:pseudo) set ident nouveau_ident"
            putdcc $onyx(idx) ":$onyx(gs:pseudo) Notice $pseudo :Permet de changer l'ident du bot."
        } elseif {$data2=="set" && $data3=="host"} {
            putdcc $onyx(idx) ":$onyx(gs:pseudo) Notice $pseudo :Syntax: /msg $onyx(gs:pseudo) set host nouveau_host"
            putdcc $onyx(idx) ":$onyx(gs:pseudo) Notice $pseudo :Permet de changer l'host du bot."
        } elseif {$data2=="set" && $data3=="realname"} {
            putdcc $onyx(idx) ":$onyx(gs:pseudo) Notice $pseudo :Syntax: /msg $onyx(gs:pseudo) set realname nouveau_realname"
            putdcc $onyx(idx) ":$onyx(gs:pseudo) Notice $pseudo :Permet de changer le realname du bot."
        } elseif {$data2=="set" && $data3=="salon"} {
            putdcc $onyx(idx) ":$onyx(gs:pseudo) Notice $pseudo :Syntax: /msg $onyx(gs:pseudo) set salon #nouveau_salon"
            putdcc $onyx(idx) ":$onyx(gs:pseudo) Notice $pseudo :Permet de changer le salon principal du bot."
        } elseif {$data2=="set" && $data3=="list"} {
            putdcc $onyx(idx) ":$onyx(gs:pseudo) Notice $pseudo :Syntax: /msg $onyx(gs:pseudo) set list"
            putdcc $onyx(idx) ":$onyx(gs:pseudo) Notice $pseudo :Permet de montrer les fixatioms actuelles du bot."
        } else { putdcc $onyx(idx) ":$onyx(gs:pseudo) Notice $pseudo :Aucune aide disponible sur cette commande." }
}

##########
# gs:set #
##########
proc gs:set {arg} {
	global onyx
	set arg [join [split $arg]]
	set pseudo [lindex $arg 0]
	set vpseudo [string tolower $pseudo]
	set data [string tolower [string trim [lindex $arg 2] :]]
	set data2 [lindex $arg 3]
	set vdata2 [string tolower $data2]
        if {![info exists onyx(os:$vpseudo)]} { putdcc $onyx(idx) ":$onyx(gs:pseudo) NOTICE $pseudo :Commande Auth : /msg $onyx(os:pseudo) auth pseudo motdepagse"; return 0 }
        if {![matchattr $onyx(os:$vpseudo) n]} { putdcc $onyx(idx) ":$onyx(gs:pseudo) NOTICE $pseudo :Votre  level est imsuffisant pour utilser cette commande."; return 0 }
	if {$data==""} { 
          putdcc $onyx(idx) ":$onyx(gs:pseudo) Notice $pseudo :PSEUDO Permet de changer le pseudo du bot."
          putdcc $onyx(idx) ":$onyx(gs:pseudo) Notice $pseudo :IDENT Permet de changer l'ident du bot."
          putdcc $onyx(idx) ":$onyx(gs:pseudo) Notice $pseudo :HOST Permet de changer l'host du bot."
          putdcc $onyx(idx) ":$onyx(gs:pseudo) Notice $pseudo :REALNAME Permet de changer le realname du bot."
          putdcc $onyx(idx) ":$onyx(gs:pseudo) Notice $pseudo :SALON Permet de changer le salon principal du bot."
          putdcc $onyx(idx) ":$onyx(gs:pseudo) Notice $pseudo :LIST Permet de montrer les fixatioms actuelles du bot."
          return 0 
	}
	if {$data=="pseudo"} {
          if {$data2==""} { putdcc $onyx(idx) ":$onyx(gs:pseudo) NOTICE $pseudo :Commande Set pseudo : /msg $onyx(gs:pseudo) set pseudo nouveau_pseudo"; return 0 }
          if {$vdata2==[string tolower $onyx(gs:pseudo)]} { putdcc $onyx(idx) ":$onyx(gs:pseudo) NOTICE $pseudo :Pseudo Identique."; return 0 }
          set new_pseudo $data2
          set onyx(verif:pseudo_bot) "gs $new_pseudo $pseudo 0"
          putdcc $onyx(idx) ":$onyx(gs:pseudo) WHO $new_pseudo"
        }
	if {$data=="ident"} {
          if {$data2==""} { putdcc $onyx(idx) ":$onyx(gs:pseudo) NOTICE $pseudo :Commande Set ident : /msg $onyx(gs:pseudo) set ident nouveau_ident"; return 0 }
          putdcc $onyx(idx) ":$onyx(gs:pseudo) CHGIDENT $onyx(gs:pseudo) $data2"
          set onyx(gs:ident) $data2
          onyx:gestion
          putdcc $onyx(idx) ":$onyx(gs:pseudo) NOTICE $pseudo :Changement de l'ident rugsi."
          if {$onyx(os:console)=="1"} { putdcc $onyx(idx) ":$onyx(gs:pseudo) PRIVMSG $onyx(salon) :$onyx(os:couleur_evmt)Set ident$onyx(os:couleur_deco) : $onyx(os:couleur_txt)utilis par $pseudo" }
        }
	if {$data=="host"} {
          if {$data2==""} { putdcc $onyx(idx) ":$onyx(gs:pseudo) NOTICE $pseudo :Commande Set host : /msg $onyx(gs:pseudo) set host nouveau_host"; return 0 }
          putdcc $onyx(idx) ":$onyx(gs:pseudo) CHGHOST $onyx(gs:pseudo) $data2"
          set onyx(os:host:[string tolower $onyx(gs:pseudo)]) $data2
          set onyx(gs:host) $data2
          onyx:gestion
          putdcc $onyx(idx) ":$onyx(gs:pseudo) NOTICE $pseudo :Changement de l'host rugsi."
          if {$onyx(os:console)=="1"} { putdcc $onyx(idx) ":$onyx(gs:pseudo) PRIVMSG $onyx(salon) :$onyx(os:couleur_evmt)Set host$onyx(os:couleur_deco) : $onyx(os:couleur_txt)utilis par $pseudo" }
        }
	if {$data=="realname"} {
          if {$data2==""} { putdcc $onyx(idx) ":$onyx(gs:pseudo) NOTICE $pseudo :Commande Set realname : /msg $onyx(gs:pseudo) set realname nouveau_realname"; return 0 }
          putdcc $onyx(idx) ":$onyx(gs:pseudo) CHGNAME $onyx(gs:pseudo) [lrange $arg 3 end]"
          set onyx(gs:real) [lrange $arg 3 end]
          onyx:gestion
          putdcc $onyx(idx) ":$onyx(gs:pseudo) NOTICE $pseudo :Changement du realname rugsi."
          if {$onyx(os:console)=="1"} { putdcc $onyx(idx) ":$onyx(gs:pseudo) PRIVMSG $onyx(salon) :$onyx(os:couleur_evmt)Set realname$onyx(os:couleur_deco) : $onyx(os:couleur_txt)utilis par $pseudo" }
        }
	if {$data=="salon"} {
          if {$data2==""} { putdcc $onyx(idx) ":$onyx(gs:pseudo) NOTICE $pseudo :Commande Set salon : /msg $onyx(gs:pseudo) set salon #nouveau_salon"; return 0 }
          if {[string index $data2 0]!="#"} { putdcc $onyx(idx) ":$onyx(gs:pseudo) NOTICE $pseudo :Vous avez oublier le # devant le nouveau salon."; return 0 } 
          if {$vdata2==[string tolower $onyx(gs:salon)]} { putdcc $onyx(idx) ":$onyx(gs:pseudo) NOTICE $pseudo :Salon Identique."; return 0 }
          putdcc $onyx(idx) ":$onyx(gs:pseudo) PART $onyx(gs:salon) :Changement de salon"
          set onyx(gs:salon) $data2
          onyx:gestion
          putdcc $onyx(idx) ":$onyx(gs:pseudo) JOIN $onyx(gs:salon)"
          putdcc $onyx(idx) ":$onyx(gs:pseudo) MODE $onyx(gs:salon) $onyx(gs:mode_pseudo) $onyx(gs:pseudo)"
          putdcc $onyx(idx) ":$onyx(gs:pseudo) NOTICE $pseudo :Changement du salon rugsi."
          if {$onyx(os:console)=="1"} { putdcc $onyx(idx) ":$onyx(gs:pseudo) PRIVMSG $onyx(salon) :$onyx(os:couleur_evmt)Set salon$onyx(os:couleur_deco) : $onyx(os:couleur_txt)utilis par $pseudo" }
        }
	if {$data=="list"} {
          putdcc $onyx(idx) ":$onyx(gs:pseudo) NOTICE $pseudo :Pseudo: $onyx(gs:pseudo)"
          putdcc $onyx(idx) ":$onyx(gs:pseudo) NOTICE $pseudo :Ident: $onyx(gs:ident)"
          putdcc $onyx(idx) ":$onyx(gs:pseudo) NOTICE $pseudo :Host: $onyx(gs:host)"
          putdcc $onyx(idx) ":$onyx(gs:pseudo) NOTICE $pseudo :Realname: $onyx(gs:real)"
          putdcc $onyx(idx) ":$onyx(gs:pseudo) NOTICE $pseudo :Salon: $onyx(gs:salon)"
        }
}

############
# gs:salon #
############
proc gs:salon {arg} {
	global onyx
	set arg [join [split $arg]]
	set pseudo [lindex $arg 0]
	set vpseudo [string tolower $pseudo]
	set vcmd [string tolower [lindex $arg 2]]
	set salon [string tolower [lindex $arg 3]]
        if {![info exists onyx(os:$vpseudo)]} { putdcc $onyx(idx) ":$onyx(gs:pseudo) NOTICE $pseudo :Commande Auth : /msg $onyx(os:pseudo) auth pseudo motdepagse"; return 0 }
        if {![matchattr $onyx(os:$vpseudo) m]} { putdcc $onyx(idx) ":$onyx(gs:pseudo) NOTICE $pseudo :Votre  level est imsuffisant pour utilser cette commande."; return 0 }
        if {$vcmd==""} {
          putdcc $onyx(idx) ":$onyx(gs:pseudo) NOTICE $pseudo :SALON ADD Permet d'ajouter un salon."
          putdcc $onyx(idx) ":$onyx(gs:pseudo) NOTICE $pseudo :SALON DEL Permet de retir un salon."
          putdcc $onyx(idx) ":$onyx(gs:pseudo) NOTICE $pseudo :SALON LIST Permet de voir la liste des salons gard."
        }
        if {$vcmd=="add"} {
          if {$salon=="" || [string index $salon 0]!="#"} { putdcc $onyx(idx) ":$onyx(gs:pseudo) NOTICE $pseudo :Commande Salon add : /msg $onyx(gs:pseudo) salon add #salon"; return 0 }
	  set stop 0
	  catch {open db/gs_onyx/salons.db r} liste
	  while {![eof $liste]} {
	    gets $liste verif
	      if {[string tolower $salon]==[string tolower [lindex $verif 0]]} { 
                putdcc $onyx(idx) ":$onyx(gs:pseudo) NOTICE $pseudo :$salon est dj dans la liste des salons gard par $onyx(gs:pseudo)."
                set stop 1
                break 
	      }
	  }
	  catch {close $liste}
	  if {$stop==1} { return 0 }
	  set addsalons [open db/gs_onyx/salons.db a]
	  puts $addsalons "$salon"
	  close $addsalons
	  putdcc $onyx(idx) ":$onyx(gs:pseudo) NOTICE $pseudo :$salon vient d'tre ajout  la liste des salons gard par $onyx(gs:pseudo)."
          putdcc $onyx(idx) ":$onyx(gs:pseudo) JOIN $salon"
          putdcc $onyx(idx) ":$onyx(gs:pseudo) MODE $salon $onyx(gs:mode:salon) $onyx(gs:pseudo)"
          set onyx(gs:newsalon:$salon) ok
          putdcc $onyx(idx) ":$onyx(gs:pseudo) TOPIC $salon"
	  if {$onyx(os:console)=="1"} { putdcc $onyx(idx) ":$onyx(gs:pseudo) PRIVMSG $onyx(salon) :$onyx(os:couleur_evmt)Salon add$onyx(os:couleur_deco) : $onyx(os:couleur_txt)utilis par $pseudo ($salon)" }
	}
        if {$vcmd=="del"} {
          if {$salon=="" || [string index $salon 0]!="#"} { putdcc $onyx(idx) ":$onyx(gs:pseudo) NOTICE $pseudo :Commande Salon del : /msg $onyx(gs:pseudo) salon del #salon"; return 0 }
          set stop 0
	  catch {open db/gs_onyx/salons.db r} liste
	  while {![eof $liste]} {
	    gets $liste verif
	    if {$verif!=""} { 
              if {[string tolower $salon]!=[string tolower [lindex $verif 0]]} { lappend salongarde "$verif" } else { set stop 1 }
            }
	  }
	  catch {close $liste}
	  if {$stop==0} { 
	    putdcc $onyx(idx) ":$onyx(gs:pseudo) NOTICE $pseudo :$salon n'est pas dans la liste des salons gard par $onyx(gs:pseudo)." 
	    return 0 
	  } else {
	    if [info exists salongarde] {
	    set del [open db/gs_onyx/salons.db w+]
	    foreach scan_salon $salongarde { puts $del "$scan_salon" }
	    close $del
	    } else {
	      set del [open db/gs_onyx/salons.db w+]
	      close $del
	    }
	  putdcc $onyx(idx) ":$onyx(gs:pseudo) NOTICE $pseudo :$salon vient d'tre supprim de la liste des salons gard par $onyx(gs:pseudo)."
          putdcc $onyx(idx) ":$onyx(gs:pseudo) PART $salon :Salon supprim des salons gard par $pseudo"
	  if {$onyx(os:console)=="1"} { putdcc $onyx(idx) ":$onyx(gs:pseudo) PRIVMSG $onyx(salon) :$onyx(os:couleur_evmt)Salon del$onyx(os:couleur_deco) : $onyx(os:couleur_txt)utilis par $pseudo ($salon)" }
	  }
        }
        if {$vcmd=="list"} {
	  set num 0
	  catch {open db/gs_onyx/salons.db r} liste
	  putdcc $onyx(idx) ":$onyx(gs:pseudo) NOTICE $pseudo :1,1---------- 0Liste des salons gard par $onyx(gs:pseudo) 1----------"
	  putdcc $onyx(idx) ":$onyx(gs:pseudo) NOTICE $pseudo :"
	  while {![eof $liste]} {
	    gets $liste salon_garde
	    if {$salon_garde!=""} { 
              incr num 1
              set salon_garde2 [lindex $salon_garde 0]
              putdcc $onyx(idx) ":$onyx(gs:pseudo) NOTICE $pseudo : 1 \[03 $num 01\] $salon_garde2" 
	    }
	  }
          catch {close $liste}
	  if {$num=="0"} { putdcc $onyx(idx) ":$onyx(gs:pseudo) NOTICE $pseudo :Aucun salon." }
	  if {$onyx(os:console)=="1"} { putdcc $onyx(idx) ":$onyx(gs:pseudo) PRIVMSG $onyx(salon) :$onyx(os:couleur_evmt)Salon list$onyx(os:couleur_deco) : $onyx(os:couleur_txt)utilis par $pseudo" }
        }
}

############
# gs:event #
############
proc gs:event {arg} {
   global egg onyx admin
   set arg [join [split $arg]]
switch -exact [lindex $arg 1] {
  "PRIVMSG" 
    { 
    set pseudo [string trim [lindex $arg 0] :]
    set vpseudo [string tolower $pseudo]
    set pour [lindex $arg 2]
    set vpour [string tolower $pour]
    set commande [string tolower [string trim [lindex $arg 3] :]]
    set commande2 [string trim $commande $onyx(prefix)]
    set data [lrange $arg 3 end]
    if {$vpour==[string tolower $onyx(gs:pseudo)] || $vpour==[string tolower $onyx(gs:salon)]} { 
      if {[string tolower $onyx(gs:salon)]==$onyx(salon2) && $vpour!=[string tolower $onyx(gs:pseudo)]} { return 0 }
      if {$commande2=="help"} { if {[global:flood "gs $pseudo"]!="ok"} { return 0 }; gs:help "$pseudo $data" }
      if {$commande2=="set"} { if {[global:flood "gs $pseudo"]!="ok"} { return 0 }; gs:set "$pseudo $data" }
      if {$commande2=="salon"} { if {[global:flood "gs $pseudo"]!="ok"} { return 0 }; gs:salon "$pseudo $data" }
    }
    }
  "KICK" 
    { 
    set pseudo [string trim [lindex $arg 0] :]
    set salon [lindex $arg 2]
    set vsalon [string tolower $salon]
    set pseudo2 [lindex $arg 3]
    set raison [join [string trim [lrange $arg 4 end] :]]
    if {$onyx(gs:global:active)=="1" && $pseudo2==$onyx(gs:pseudo)} {
    catch {open db/gs_onyx/salons.db r} salons
    while {![eof $salons]} { 
      gets $salons salon_garde
      if {$salon_garde!=""} { 
        if {$salon_garde!=""} { 
          putdcc $onyx(idx) ":$onyx(gs:pseudo) JOIN $salon_garde"
          putdcc $onyx(idx) ":$onyx(gs:pseudo) MODE $salon_garde $onyx(gs:mode:salon) $onyx(gs:pseudo)"
        } 
      }
    }
    catch {close $salons} 
    }
    }
  "MODE" 
    { 
    set salon [lindex $arg 2]
    set ac_mode [string match *-*o* [lindex $arg 3]]
    set pseudo_bot [lindex $arg 4]
    if {$onyx(gs:global:active)=="1" && $pseudo_bot==$onyx(gs:pseudo) && $ac_mode=="1"} {
      putdcc $onyx(idx) ":$onyx(gs:pseudo) MODE $salon $onyx(gs:mode_pseudo) $onyx(gs:pseudo)" 
    }
    }
  "KILL" 
    {
    set pseudo [lindex $arg 2]
    if {$pseudo==$onyx(gs:pseudo)} { gs:lancement }
    }
  "TOPIC" 
    { 
    set bot [lindex $arg 2]
    set salon [lindex $arg 2]
    set vsalon [string tolower $salon]
    set qui [lindex $arg 3]
    set quand [lindex $arg 4]
    set quoi [join [string trimleft [lrange $arg 5 end] :]]
    catch {open db/gs_onyx/salons.db r} liste
      while {![eof $liste]} {
        gets $liste verif
        if {$verif!=""} {
          set ou [lindex $verif 0]
	  if {[string tolower $salon]!=$ou} { lappend modif_salongarde "$verif" } else { lappend modif_salongarde "$ou $quand $qui $quoi" }
        }
      }
      catch {close $liste}
      set modif_t [open db/gs_onyx/salons.db w+]
      foreach scan_salon $modif_salongarde { puts $modif_t "$scan_salon" }
      close $modif_t
    }
  "331" 
    { 
    set bot [lindex $arg 2]
    set salon [lindex $arg 3]
    set vsalon [string tolower $salon]
    if {$bot=="$onyx(gs:pseudo)" && [info exists onyx(gs:resalon:$vsalon)]} {
      catch {open db/gs_onyx/salons.db r} liste
      while {![eof $liste]} {
        gets $liste salon_garde
        if {$salon_garde!=""} { 
          set ou [lindex $salon_garde 0]
          set quand [lindex $salon_garde 1]
          set qui [lindex $salon_garde 2]
          set quoi [lrange $salon_garde 3 end]
          putdcc $onyx(idx) ":$onyx(gs:pseudo) TOPIC $ou $qui $quand :$quoi" 
	}
      }
      catch {close $liste}
      unset onyx(gs:resalon:$vsalon)
    }
    if {$bot=="$onyx(gs:pseudo)" && [info exists onyx(gs:newsalon:$vsalon)]} {
      catch {open db/gs_onyx/salons.db r} liste
      while {![eof $liste]} {
        gets $liste verif
        if {$verif!=""} {
          set ou [lindex $verif 0]
          set quand [lindex $verif 1]
          set qui [lindex $verif 2]
          set quoi [lrange $verif 3 end]         
	  if {[string tolower $salon]!="$ou"} {
            lappend modif_salongarde "$verif"
          } else {
            if {$quand==""} {
              regsub -all "salle" $onyx(gs:topic) "$salon" onyx(gs:topic2)
              putdcc $onyx(idx) ":$onyx(gs:pseudo) TOPIC $salon :$onyx(gs:topic2)"
              lappend modif_salongarde "$ou [unixtime] $onyx(gs:pseudo) $onyx(gs:topic2)"
            } else {
              putdcc $onyx(idx) ":$onyx(gs:pseudo) TOPIC $ou $quand $qui :$quoi"
              lappend modif_salongarde "$ou $quand $qui $quoi"
            }
          }
        }
      }
      catch {close $liste}
      set modif_t [open db/gs_onyx/salons.db w+]
      foreach scan_salon $modif_salongarde { puts $modif_t "$scan_salon" }
      close $modif_t
      unset onyx(gs:newsalon:$vsalon)
    }
    }
  "332" 
    { 
    set bot [lindex $arg 2]
    set salon [lindex $arg 3]
    set vsalon [string tolower $salon]
    set quoi [join [string trimleft [lrange $arg 4 end] :]]
    if {$bot=="$onyx(gs:pseudo)"} {
      catch {open db/gs_onyx/salons.db r} liste
      while {![eof $liste]} {
        gets $liste verif
        if {$verif!=""} {
          set ou [lindex $verif 0]
	  if {[string tolower $salon]!=$ou} { lappend modif_salongarde "$verif" } else { lappend modif_salongarde "$vsalon quand qui $quoi" }
        }
      }
      catch {close $liste}
      set modif_t [open db/gs_onyx/salons.db w+]
      foreach scan_salon $modif_salongarde { puts $modif_t "$scan_salon" }
      close $modif_t
    }
    }
  "333" 
    { 
    set bot [lindex $arg 2]
    set salon [lindex $arg 3]
    set vsalon [string tolower $salon]
    set qui [lindex $arg 4]
    set quand [lindex $arg 5]
    if {$bot=="$onyx(gs:pseudo)"} {
      catch {open db/gs_onyx/salons.db r} liste
      while {![eof $liste]} {
        gets $liste verif
        if {$verif!=""} {
          set ou [lindex $verif 0]
          set quoi [lrange $verif 3 end]
	  if {[string tolower $salon]!=$ou} { lappend modif_salongarde "$verif" } else { lappend modif_salongarde "$vsalon $quand $qui $quoi" }
        }
      }
      catch {close $liste}
      set modif_t [open db/gs_onyx/salons.db w+]
      foreach scan_salon $modif_salongarde { puts $modif_t "$scan_salon" }
      close $modif_t
    }
    }


  }
}

##########
# gs:web #
##########
proc gs:web {arg} {
   global onyx 
   set htmlpage [lindex $arg 0]
   set num_menu [lindex $arg 1]
   puts $htmlpage "<table width=\"85%\" align=\"center\" id=\"menu$num_menu\" style=\"display: none; text-align: center\"><tr><td>"
   puts $htmlpage "<table width=\"100%\" align=\"center\"><tr>"
   puts $htmlpage "<td width=\"60%\" valign=\"top\">"
   puts $htmlpage "<font class=\"text1\">Pseudo du GuardServ :</font> $onyx(gs:pseudo)<br>"
   puts $htmlpage "<font class=\"text1\">Ident du GuardServ :</font> $onyx(gs:ident)<br>"
   puts $htmlpage "<font class=\"text1\">Host du GuardServ :</font> $onyx(gs:host)<br>"
   puts $htmlpage "<font class=\"text1\">Modes du GuardServ :</font> $onyx(gs:mode)<br>"
   puts $htmlpage "<font class=\"text1\">Realname du GuardServ :</font> $onyx(gs:real)<br>"
   puts $htmlpage "<font class=\"text1\">Salon du GuardServ :</font> $onyx(gs:salon)<br>"
   puts $htmlpage "<font class=\"text1\">Modes du salon :</font> $onyx(gs:mode_salon)<br>"
   puts $htmlpage "<font class=\"text1\">Mode sur le salon :</font> $onyx(gs:mode_pseudo)<br>"
   if {$onyx(gs:global:active)=="1"} { puts $htmlpage "<font class=\"text1\">GuardServ activ :</font> Oui<br>" } else { puts $htmlpage "<font class=\"text1\">GuardServ activ :</font> Non<br>" }
   puts $htmlpage "</td><td valign=\"top\">"
   puts $htmlpage "<font class=\"text1\">Mode sur les salons :</font> $onyx(gs:mode:salon)<br>"
   puts $htmlpage "</td></tr></table>"
   puts $htmlpage "<div align=\"center\">"
   puts $htmlpage "<h2><font class=\"text2\">Liste des salons</font></h2>"
   set num 0
   catch {open db/gs_onyx/salons.db r} liste_salons
   while {![eof $liste_salons]} {
     gets $liste_salons salon_htm
     if {$salon_htm!=""} { 
       incr num 1
       puts $htmlpage "<font class=\"text2\">[lindex $salon_htm 0]</font><br>"
     }
   }
   catch {close $liste_salons}
   if {$num=="0"} { puts $htmlpage "Aucun salon" }
   puts $htmlpage "</div><br>"
   puts $htmlpage "</td></tr></table>"
}